/*
 * Copyright 2011 Daniel Josefsson
 *
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package se.dannej.fakehttpserver;

import org.hamcrest.Description;

import se.dannej.fakehttpserver.junit.FakeServerRule;

/**
 * Interface for fake servers. The fake server may be given to the {@link FakeServerRule}
 * to be shutdown and finally asserted after finishing a test.
 */
public interface FakeServer {
	/**
	 * Start server.
	 */
	void start();
	/**
	 * Stops server if running, otherwise does nothing.
	 */
	void stop();
	
	/**
	 * @param mismatchDescription description populated if expectations were not met
	 * @return true if all expectations have been satisfied.
	 */
	boolean isSatisfied(Description mismatchDescription);
}
